Bug 270421 - clurgmgrd crashes when resources are deeply nested
clurgmgrd crashes when resources are deeply nested
Status: CLOSED ERRATA
Product: Red Hat Cluster Suite
Classification: Red Hat
Component: rgmanager (Show other bugs)
4
All All
medium Severity low
: ---
: ---
Assigned To: Lon Hohberger
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-08-31 02:51 EDT by Andrew Ryan
Modified: 2009-04-16 16:22 EDT (History)
1 user (show)

See Also:
Fixed In Version: RHBA-2008-0791
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-07-25 15:15:32 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
cluster.conf w/ extreme nesting (29.99 KB, application/octet-stream)
2007-08-31 02:51 EDT, David Robinson
no flags Details
corefile produced (1.15 MB, application/octet-stream)
2007-08-31 02:53 EDT, David Robinson
no flags Details
backtrace (24.42 KB, text/plain)
2007-08-31 02:53 EDT, David Robinson
no flags Details
Caps depth at 12 and increases the query buffer sizes to 1k (2.05 KB, patch)
2007-09-18 17:46 EDT, Lon Hohberger
no flags Details | Diff
Example output of rg_test given the cluster.conf w/ extreme nesting. (45.61 KB, text/plain)
2007-09-18 17:47 EDT, Lon Hohberger
no flags Details

  None (edit)
Description David Robinson 2007-08-31 02:51:59 EDT
Description of problem:
The config file attached causes clurgmgrd to crash, and since it crashes the
system is rebooted.

Version-Release number of selected component (if applicable):
rgmanager-1.9.68-1

How reproducible:
100%

Steps to Reproduce:
1. Setup a cluster and use the cluster.conf attached
2. Start ccsd, cman, etc.
3. When rgmanager is started it will crash
  
Actual results:
Aug 31 06:04:53 node2 clurgmgrd[28807]: <notice> Resource Group Manager Starting 
Aug 31 06:04:53 node2 clurgmgrd[28807]: <info> Loading Service Data 
Aug 31 06:04:55 node2 clurgmgrd[28806]: <crit> Watchdog: Daemon died, rebooting...

Expected results:
The config attached isn't exactly ideal, but clurgmgrd shouldn't crash. It
should either work, or clurgmgrd should refuse to start.

Additional info:
backtrace is attached. The original cluster configuration was created by a
customer after misinterpreting our advice. attached cluster.conf (slightly
modified from customer's) reproduced the problem for me (on i686, I haven't
tested x86_64).
Comment 1 David Robinson 2007-08-31 02:51:59 EDT
Created attachment 182861 [details]
cluster.conf w/ extreme nesting
Comment 2 David Robinson 2007-08-31 02:53:03 EDT
Created attachment 182881 [details]
corefile produced
Comment 3 David Robinson 2007-08-31 02:53:57 EDT
Created attachment 182901 [details]
backtrace
Comment 4 Lon Hohberger 2007-09-04 15:31:07 EDT
Wow, that's impressive.

You don't have to nest that deep to get the same effect in 4.5 and later...
Comment 5 Lon Hohberger 2007-09-18 17:12:11 EDT
I agree that it shouldn't crash, but disagree on the refuse to start bit, given
that configuration can be changed run-time (i.e., the user can fix it later). 
Services are considered independent of one another: one service's configuration
- should not affect whether or not another independent service is allowed to start.

At any rate, to fix this, we either need to cap maximum tree depth (Conga caps
it at 10 levels, IIRC) or make the query buffers dynamically allocated.  In the
case of the former, we need to prominently state that the user's tree is too deep.
Comment 6 Lon Hohberger 2007-09-18 17:46:50 EDT
Created attachment 198881 [details]
Caps depth at 12 and increases the query buffer sizes to 1k
Comment 7 Lon Hohberger 2007-09-18 17:47:27 EDT
Created attachment 198891 [details]
Example output of rg_test given the cluster.conf w/ extreme nesting.
Comment 9 RHEL Product and Program Management 2007-11-28 22:59:08 EST
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 13 errata-xmlrpc 2008-07-25 15:15:32 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2008-0791.html

Note You need to log in before you can comment on or make changes to this bug.